
package de.ivu.elect.presentation.entschaedigung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.entschaedigung.boundary.AuszahlungConversationStore;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungExtendedDAO;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungEdit;
import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.entschaedigung.entity.AuszahlungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractAuszahlungEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractAuszahlungEditNoScopeView.VIEW_ID, useCase = UseCasePermission.AUSZAHLUNG_EDIT)
public abstract class AbstractAuszahlungEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Auszahlung>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "auszahlungEditView";

  public static final String VIEW_ID = "/entschaedigung/auszahlung-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/entschaedigung/auszahlung-search.xhtml";

  @Inject
  protected transient AuszahlungExtendedDAO extendedDAO;

  @Inject
  protected transient AuszahlungEdit edit;

  @Inject
  @ConversationGroup(AuszahlungConversationStore.class)
  protected transient AuszahlungConversationStore conversationStore;

  @Inject
  protected transient AuszahlungMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient AuszahlungEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Auszahlung getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Auszahlung entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUSZAHLUNG_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Auszahlung entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.AUSZAHLUNG_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.AUSZAHLUNG_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUSZAHLUNG_EDIT)
  @Override
  public String save() {
    Auszahlung entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Auszahlung entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Auszahlung entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Auszahlung entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.AUSZAHLUNG_EDIT);
  }
  
  @Redirect
  public String edit(Auszahlung entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class AuszahlungEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Auszahlung,   de.ivu.elect.business.entschaedigung.entity.AuszahlungPK  > {

    private static final long serialVersionUID = 1L;
  }
}
